library examplePlugin;

uses
  SysUtils,
  Classes,
  unPlugin in 'unPlugin.pas',
  unSupport in 'unSupport.pas';

{$R *.res}
var installCount : integer;
    instances : array[1..1000] of TPlugin;

function createPlugin(pluginNameX : pchar;pluginHost:integer):integer;
var
   name : string;
Begin
   name   := pluginNameX;
   inc(installCount);
   if installCount>999 then installcount := 1;
   instances[installCount] := TPlugin.Create(name,pluginHost);
   Result := installCount;
End;

function infoReceivedStart(pluginAddr:integer; action,param:pchar) : pchar;
var s : string;
    pVal : pchar;
Begin
   if string(action)='uninstall' then begin
     TPlugin(instances[pluginAddr]).infoReceived(action,param);
     TPlugin(instances[pluginAddr]).free;
     Result := nil;
   end else begin
     s := TPlugin(instances[pluginAddr]).infoReceived(action,param);
     GetMem(pVal,length(s)+1);
     pVal := StrPCopy(pVal, s);
     Result := pVal;
   end;
End;

procedure infoReceivedEnd(pVal : pchar);
Begin
   FreeMem(pVal);
End;


procedure registerCallback(procAddrStart,procAddrEnd: pointer);
Begin
   @sendInfoDllStart := procAddrStart;
   @sendInfoDllEnd := procAddrEnd;
End;


Exports
  createPlugin,
  registerCallback,
  infoReceivedStart,
  infoReceivedEnd;
begin
end.


 